// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300

#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv;
#else
_centroid in vec2 uv;
#endif

#else

varying vec2 uv;

#endif

#include "uniformShaderConstants.h"
#include "uniformPerFrameConstants.h"
#include "util.h"

#include "lib/Noise & Fbm.glsl"

#include "Settings/Experimental.ugspe"

varying vec3 pos;

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;

void main()
{
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE)
	vec4 diffuse = texture2D( TEXTURE_0, uv );
#else
	vec4 diffuse = texture2D_AA(TEXTURE_0, uv );
#endif

#ifdef ALPHA_TEST
	if(diffuse.a < 0.5)
		discard;
#endif

vec2 p = 1. + 3. * pos.xz;
float f = fbm(p * fbm(p * fbm(p)));
float cover = .6;
float sharpness = .01;
  float c = f - (1. - cover);
  if ( c < .0 )
    c = .0;
  f = 1. - (pow(sharpness, c));

vec2 ps = 1. + 3. * pos.xz;
float fs = fbm(p * fbm(p * fbm(p)));
float covers = .3;
float sharpnesss = .001;
float cs = fs - (1. - covers);
if ( cs < .0 )
cs = .0;
fs = 1. - (pow(sharpnesss, cs));


vec4 color = CURRENT_COLOR;

vec4 magic_sky = mix(vec4(0.), vec4(vec3(.3, .15, .75), 1.), f);
magic_sky -= mix(vec4(0.), vec4(vec3(.3, .15, .5), 1.), fs);

#ifdef MAGIC_END_SKY
	gl_FragColor = color * diffuse + magic_sky;
#else
  gl_FragColor = color * diffuse;
#endif
}
