/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
All Random and noise (Except Voronoise) from :

https://gist.github.com/patriciogonzalezvivo/670c22f3966e662d2f83
*/

highp float rand(highp vec2 n) 
{ 	
return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453); 
} 

float dither(vec2 p)
{
return pow(rand(50. * sin(p + fract(TIME * 0.0000004))), 1.);
}

highp float noise(highp vec2 p)
{ 	
   highp vec2 ip = floor(p); 	
   highp vec2 u = fract(p); 	
   u = u*u*(3.0-2.0*u); 	 	
   highp float res = mix( 		mix(rand(ip),rand(ip+vec2(1.0,0.0)),u.x), 		mix(rand(ip+vec2(0.0,1.0)),rand(ip+vec2(1.0,1.0)),u.x),u.y); 	

return res*res; 
}

highp vec3 permute(highp vec3 x) 
{ 
return mod(((x*34.0)+1.0)*x, 289.0); 
} 

highp float snoise(highp vec2 v)
{ 
   highp vec4 C = vec4(0.211324865405187, 0.366025403784439, -0.577350269189626, 0.024390243902439); 
   highp vec2 i = floor(v + dot(v, C.yy)); 
   highp vec2 x0 = v - i + dot(i, C.xx); 
highp vec2 i1; 
   i1 = (x0.x > x0.y) ? vec2(1.0, 0.0) : vec2(0.0, 1.0); 
   highp vec4 x12 = x0.xyxy + C.xxzz; 
   x12.xy -= i1; 
   i = mod(i, 289.0); 
   highp vec3 p = permute( permute( i.y + vec3(0.0, i1.y, 1.0 )) + i.x + vec3(0.0, i1.x, 1.0 )); 
   highp vec3 m = max(0.5 - vec3(dot(x0,x0), dot(x12.xy,x12.xy), dot(x12.zw,x12.zw)), 0.0); 
   m = m*m ; 
   m = m*m ; 
   highp vec3 x = 2.0 * fract(p * C.www) - 1.0; 
   highp vec3 h = abs(x) - 0.5; 
   highp vec3 ox = floor(x + 0.5); 
   highp vec3 a0 = x - ox; 
   m *= 1.79284291400159 - 0.85373472095314 * ( a0*a0 + h*h ); 
highp vec3 g; 
   g.x = a0.x * x0.x + h.x * x0.y; 
   g.yz = a0.yz * x12.xz + h.yz * x12.yw; 

return 130.0 * dot(m, g); 
}

/*
Voronoise from :

https://www.shadertoy.com/view/WdfyRl
*/

highp vec2 random2(highp vec2 uv){
uv = vec2(dot(uv,vec2(127.1,311.7)),
dot(uv,vec2(269.5,183.3)));
return -1.0 + 2.0 * fract(sin(uv) * 43758.5453123);
}

highp float vnoise(highp vec2 uv){
highp float cellNum = 10.;
uv *= cellNum;
highp vec2 i = floor(uv);
highp vec2 f = fract(uv);
highp float minDist = 1.;
for (int y = -1; y <= 1; y++)
{
for (int x = -1; x <= 1; x++)
{
highp vec2 neighbor = vec2(x, y);
highp vec2 point = random2(i + neighbor);
point = 0.5 + 0.5 * sin(TIME + 6.2831 * point);
highp float dist = length(neighbor + point - f);
minDist = min(minDist, dist);
}
}
return minDist;
}

/*
Fbm from :

https://www.shadertoy.com/view/ltBfzd
*/

highp float fbm(highp vec2 uv)
{
   highp float value = 0.0;
   highp float factor = 1.0;
    for (int i = 0; i < 7; i++)
    {
        uv += TIME * .025;
        value += noise(uv * factor) / factor;
        factor *= 2.0;
    }
    return value;
}

highp float fbmw(highp vec2 uv)
{
   highp float value = 0.0;
   highp float factor = 1.0;
    for (int i = 0; i < 1; i++)
    {
        uv += TIME * .0125;
        value += noise(uv * factor) / factor;
        factor *= 2.0;
    }
    return value;
}