/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "lib/Noise & Fbm.glsl"
#include "lib/Specular.glsl"

//KMPE MAPPING

highp float cos_between_vecs(highp vec3 v1, highp vec3 v2){
 return (v1.x * v2.x + v1.y * v2.y + v1.z * v2.z) / length(v1) / length(v2);
}

float water_wave(highp vec3 pos)
{
   pos.x += TIME * .3;
   
   float wave1 = sin(snoise(vec2(pos.x * .5 + pos.z * .45 + pos.y * .5 + pos.z * .55, pos.x * .6 + pos.z * .56 + pos.x * .2)));
   float wave2 = cos(noise(vec2(pos.z * .8 + pos.x * 1.5 + pos.x * .7, pos.x)));
   float dist = sin(TIME * 3.5 + pos.x * 3. + pos.y * 2.4 + pos.z * 2. + cos(TIME + pos.z + pos.x * .7 + pos.z * .5));

return mix(wave1, wave2, dist);
}

vec3 water_mapping(vec3 pos)
{
   highp float value = water_wave(pos + vec3(0.0, 0.0, 0.1)) - water_wave(pos); 

return vec3(0.0, 1.0, -value);
}

vec4 water_color(vec3 p, vec3 wp, float night, float sun)
{
   float water = acos(abs(cos_between_vecs(wp, water_mapping(p))));

   vec4 base_color = vec4(.2, .5, .6, 1.);

   vec4 reflection = mix(vec4(.2, .5, .6, 1.), vec4(.4, .7, .8, 1.), fbmw(wp.xz * .15 * pow(water, 1.)));

   vec3 sun_pos = vec3(100., 0., 7.);
   vec3 sun_pos2 = vec3(-100., 0., 7.);
   vec3 P = vec3(wp);
   vec3 Normal = normalize(water_mapping(p));
   vec3 V = normalize(-P);
   vec3 L = normalize(sun_pos - P);
   vec3 L2 = normalize(sun_pos2 - P);
   vec3 H = normalize(V - L);
   vec3 H2 = normalize (V - L2);
   vec4 specular = pow(max(0.0, dot(Normal, H)), 16.) * (base_color + 1.5);
   vec4 specular2 = pow(max(0.0, dot(Normal, H2)), 16.) * (base_color + 1.5);
  
   vec4 result = mix(base_color, reflection, pow(water, 2.));
   result.rgb *= mix(vec3(1.), vec3(.3, .3, .6), night);
   result.a = .3;
   result += mix(vec4(0.),  specular + specular2, sun * uv1.y);
 
return result;
}