// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "fragmentVersionSimple.h"

#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"

#include "lib/Coloring.glsl"
#include "lib/Noise & Fbm.glsl"

#include "Settings/Setting.ugspe"

varying vec4 color;
varying highp vec3 pos;
varying vec4 col;

void main()
{

    float lp = length(pos.xz);
//Day cycle
    vec4 fc = FOG_COLOR;
    float sun = pow(max(min(1. - fc.b * 1.2, 1.),0.), .5);
    float night = pow(max(min(1.0-fc.b * 1.2, 1.0), 0.0), 0.5);
    float day = 1. - night;
    float rain = 1. - pow(FOG_CONTROL.y, 11.);

//Sky Color
vec4 fog = FOG_COLOR;
vec4 sc = CURRENT_COLOR;
vec4 co = col;
fog.rgb *= 2.;
vec4 scol = mix(sc, fog, co.r);
scol.rgb = linearToneMapping(scol.rgb);
scol.rgb = mix(mix(scol.rgb, scol.rgb * vec3(.05, .5, 1.), day), fc.rgb * 10., clamp(pow(lp, 8.) * .1, 0., 1.));
scol.rgb = mix(mix(scol.rgb, scol.rgb * vec3(1., 1., 1.5), night), fc.rgb, pow(clamp(lp * 1.1, 0., 1.), 1.05));
scol.rgb = mix(mix(scol.rgb, fc.rgb * 1.75, rain), fc.rgb, pow(clamp(lp * 1.1, 0., 1.), 1.));

//GETCLOUD//
vec2 p = 1.2 + 15. * pos.xz;
float first_cloud = fbm(p) + .25 * dither(pos.xz);
float second_cloud = fbm(p * .97) + .25 * dither(pos.xz);
float third_cloud = fbm(p * .94) + .25 * dither(pos.xz);
float cover = .5;
cover = mix(cover, 2.7, rain);
cover = mix(cover, .3, night);
float sharpness = .4;
float c = first_cloud - (1. - cover);
if ( c < .0 )
c = .0;
first_cloud  = 1. - (pow(sharpness, c));
float c2 = second_cloud - (1. - cover);
if(c2 < .0)
c2 = 0.;
second_cloud = 1. - (pow(sharpness, c2));
float c3 = third_cloud - (1. - cover);
if(c3 < .0)
c3 = 0.;
third_cloud = 1. - (pow(sharpness, c3));

//Cloud Color
vec3 cloud_color = vec3(0.);
cloud_color = mix(cloud_color, vec3(1.15, 1., 1.), day);
cloud_color = mix(cloud_color, vec3(.75), night);
cloud_color = mix(cloud_color, fog.rgb, rain);

vec4 cloud = vec4(cloud_color - vec3(second_cloud * .5 + third_cloud * .4), first_cloud * 2.5);

vec4 result = mix(scol, cloud, clamp(cloud.a * 1.5, 0., 1.) * max(1. - lp * 2., 0.) * max(lp * 3., 0.));

#ifdef REALISTIC_CLOUD
  gl_FragColor = result;
#else
  gl_FragColor = scol;
#endif
}