// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

#include "vertexVersionSimple.h"

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"

attribute mediump vec4 POSITION;
attribute vec4 COLOR;

varying vec4 color;
varying highp vec3 pos;
varying vec4 col;

const float fogNear = 0.3;

void main()
{
    vec4 sky_pos = POSITION;
		sky_pos.y -= length(sky_pos.xz) * .1;
    gl_Position = WORLDVIEWPROJ * sky_pos;

    pos = POSITION.xyz;
    col = COLOR;

    color = mix( CURRENT_COLOR, FOG_COLOR, COLOR.r );
}