// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

/*
Unreal Graphic Shader 1.0

Dev : Dimas Adiyaksa

Facebook : Dimas Adiyaksa
Fanspage Facebook : Unreal Graphic Shader PE
Instagram : @dimas.adiyaksa
Twitter : @dimasadiyaksa2
Discord : Dimas 956
*/

/*
=========== DONT STEAL ANYTHING !!! ==========
*/

#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300

#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv;
#else
_centroid in vec2 uv;
#endif

#else

varying vec2 uv;

#endif

#include "uniformShaderConstants.h"
#include "uniformPerFrameConstants.h"
#include "util.h"

#include "lib/Coloring.glsl"

varying highp vec3 pos;

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;

void main()
{
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE)
	vec4 diffuse = texture2D( TEXTURE_0, uv );
#else
	vec4 diffuse = texture2D_AA(TEXTURE_0, uv );
#endif

vec4 fc = FOG_COLOR;
vec2 fcr = FOG_CONTROL;

//Detection
float day = clamp(min(fc.b, fc.b - .1), 0., 1.);
float night = 1. - day;
float sun = pow(max(min(1.-fc.b * 1.2, 1.), .0), .5);
float rain = 1. - pow(fcr.y, 11.);

float lp = length(pos);
float circle = pow(1. - clamp(lp * 1.5, 0., 1.), 60.);
circle *= mix(1., 1.6, night);
float circle2 = pow(1. - clamp(lp, 0., 1.), 4.);

vec4 ray = vec4(1., .3, 0., .15);
ray = mix(ray, vec4(1., 1., 1., .5), night);
ray *= circle2;

#ifdef ALPHA_TEST
	if(diffuse.a < 0.5)
		discard;
#endif

diffuse.rgb *= mix(vec3(1., .3, -1.), vec3(1.), night);
diffuse.rgb = linearToneMapping(diffuse.rgb);
diffuse = mix(ray, diffuse, circle);
diffuse.a *= mix(1., .0, rain);

	gl_FragColor = diffuse;
}
